## supernovas 1.5.0

=== CMakeLists.txt ===
# CMake configuration file for the SuperNOVAS library
#
# Authors: Kiran Shila, Attila Kovacs
#
# Usage: 
#   
#  To build under a 'build/' directory:
#
#    $ cmake -B build [OPTIONS]
#    $ cmake --build build
#  
#  And then to install, e.g. under '/usr/local':
#    $ [sudo ] cmake --install --prefix=/usr/local
#
#  You may install just a specific component via the --component option, such
#  as 'Runtime' or 'Development'.
#


cmake_minimum_required(VERSION 3.20)

# Project definition
project(supernovas
    VERSION 1.5.0
    DESCRIPTION "SuperNOVAS C/C++ astrometry library"
    HOMEPAGE_URL "https://smithsonian.github.io/SuperNOVAS/"
    LANGUAGES C
)

# Include required modules
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
include(FeatureSummary)

# Build options
option(BUILD_SHARED_LIBS "Build as shared libraries instead of static" OFF)
option(BUILD_DOC "Build HTML documetation" OFF)
option(BUILD_TESTING "Build regression test suite" ON)
option(BUILD_EXAMPLES "Build example programs" OFF)
option(BUILD_BENCHMARK "Build benchmark programs" OFF)
option(ENABLE_CALCEPH "Enable CALCEPH support (solsys-calceph component)" OFF)
option(ENABLE_CSPICE "Enable CSPICE support (solsys-cspice component)" OFF)

# Set feature descriptions for summary
add_feature_info(SharedLibs BUILD_SHARED_LIBS "Build as shared libraries")
add_feature_info(Documentation BUILD_DOC "Developer documentation (HTML)")
add_feature_info(Examples BUILD_EXAMPLES "Build and test example programs")
add_feature_info(Testing BUILD_TESTING "Run regression testing")
add_feature_info(Benchmarks BUILD_BENCHMARK "Build benchmarking programs")

add_feature_info(Calceph-Plugin ENABLE_CALCEPH "Optional ephemeris support via CALCEPH (solsys-calceph)")
add_feature_info(CSPICE-Plugin ENABLE_CSPICE "Optional ephemeris support via CSPICE (solsys-cspice)")

# ----------------------------------------------------------------------------
# pkg-config variables

# [.pc] Libs -- linker flags for apps
set(PC_LIBS "-lsupernovas ")

# [.pc] Libs.private -- linker flags for supernovas itself
set(PC_LIBS_PRIVATE "")


# ----------------------------------------------------------------------------
# Global build configuration

# Set output directories
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

# Debug postfix for libraries
set(CMAKE_DEBUG_POSTFIX d)

# Position Independent Code for shared libs
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Build time locations for sub-configs
link_directories(${CMAKE_BINARY_DIR}/lib)
set(supernovas_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/include)

if(WIN32)
    # Windows-specific settings
    message("Configuring for Windows...")
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
    add_compile_definitions(_CRT_SECURE_NO_WARNINGS)
endif()

if(WIN32)
    set(MATH "")
else()
    find_library(MATH_LIBRARY m REQUIRED)
    set(MATH m)
    
    # [.pc] Link applications against math lib...
    string(APPEND PC_LIBS_PRIVATE -l${MATH} " ")
endif()


if(ENABLE_CALCEPH OR ENABLE_CSPICE)
    find_package(Threads)
    
    if(CMAKE_THREAD_LIBS_INIT)
        # [.pc] apps should be linked against threads libs also...
        string(APPEND PC_LIBS_PRIVATE ${CMAKE_THREAD_LIBS_INIT} " ")
    endif()
endif()

# ----------------------------------------------------------------------------
# Extenal plugin configuration

# CALCEPH plugin
if(ENABLE_CALCEPH)
    find_package(calceph COMPONENTS Development REQUIRED CONFIG)
    set_package_properties(calceph PROPERTIES
        URL "https://calceph.imcce.fr"
        DESCRIPTION  "is designed to access the binary planetary ephemeris files"
        TYPE REQUIRED
        PURPOSE "Provides ephemeris support for supernovas"
    )
    string(APPEND PC_LIBS "-lsolsys-calceph ")
    string(APPEND PC_LIBS_PRIVATE "-lcalceph ")
endif()

# CSPICE plugin
if(ENABLE_CSPICE)
    find_library(cspice cspice REGISTRY_VIEW TARGET REQUIRED)
    string(APPEND PC_LIBS "-lsolsys-cspice ")
    string(APPEND PC_LIBS_PRIVATE "-lcspice ")
endif()

# ----------------------------------------------------------------------------
# Build the 'supernovas' library as a static OR as a shared lib.
# depending on BUILD_SHARED_LIBS

# Sources
set(SUPERNOVAS_CORE_SOURCES
    src/target.c
    src/observer.c
    src/earth.c
    src/equator.c
    src/system.c
    src/transform.c
    src/cio.c
    src/orbital.c
    src/spectral.c
    src/grav.c
    src/nutation.c
    src/timescale.c
    src/frames.c
    src/place.c
    src/calendar.c
    src/refract.c
    src/naif.c
    src/parse.c
    src/util.c
    src/planets.c
    src/itrf.c
    src/ephemeris.c
    src/solsys3.c
    src/solsys-ephem.c
)

add_library(core ${SUPERNOVAS_CORE_SOURCES})
add_library(supernovas::core ALIAS core)

set_target_properties(core PROPERTIES
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION_MAJOR}
    POSITION_INDEPENDENT_CODE ON
    EXPORT_NAME supernovas
    OUTPUT_NAME supernovas
    CLEAN_DIRECT_OUTPUT ON
)

target_include_directories(core PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

# Link with math libs as necessary
if(MATH_LIB)
    target_link_libraries(core PRIVATE ${MATH})
endif()

# ----------------------------------------------------------------------------
# Plugins

# plugins via external libraries (e.g. calceph or cspice). 
function(solsys_plugin EPHEM_LIB_NAME)
    set(PLUGIN solsys-${EPHEM_LIB_NAME})
    
    add_library(${PLUGIN} src/${PLUGIN}.c)
    add_library(supernovas::${PLUGIN} ALIAS ${PLUGIN})

    set_target_properties(${PLUGIN} PROPERTIES
        VERSION ${PROJECT_VERSION}
        SOVERSION ${PROJECT_VERSION_MAJOR}
        POSITION_INDEPENDENT_CODE ON
    )
    
    if(CMAKE_USE_PTHREADS_INIT)
        # if Threads is provided via pthread, then compile source accordingly
        target_compile_definitions(${PLUGIN} PRIVATE SUPERNOVAS_USE_PTHREAD)
    endif()
    
    target_include_directories(${PLUGIN} PRIVATE ${supernovas_INCLUDE_DIRS})
    
    find_library(EPHEM_LIBRARY ${EPHEM_LIB_NAME} REQUIRED)
    
    target_link_libraries(solsys-${EPHEM_LIB_NAME} PRIVATE
        supernovas::core
        ${EPHEM_LIBRARY}
        ${MATH}
        Threads::Threads
    )
endfunction()

# Process plugin options...
if(ENABLE_CALCEPH)
    solsys_plugin(calceph)
    find_path(CALCEPH_INCLUDE_DIR "calceph.h" REQUIRED)
    target_include_directories(solsys-calceph PRIVATE "${CALCEPH_INCLUDE_DIR}")
endif()

if(ENABLE_CSPICE)
    solsys_plugin(cspice)
    find_path(CSPICE_INCLUDE_DIR "cspice/SpiceUsr.h" REQUIRED)
    target_include_directories(solsys-cspice PRIVATE "${CSPICE_INCLUDE_DIR}")
endif()

# ----------------------------------------------------------------------------
# Testing, examples, and benchmarks...

# Run tests for the enabled options below...
enable_testing()

# Examples
if(BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

# Testing
if(BUILD_TESTING)
    add_subdirectory(test)
endif()

# Benchmarking
if(BUILD_BENCHMARK)
    add_subdirectory(benchmark)
endif()

# Documentation
if(BUILD_DOC) 
    add_subdirectory(doc)
endif()

# ----------------------------------------------------------------------------
# Install Runtime component

set(INSTALL_TARGETS core)
set(CMAKE_INSTALL_DEFAULT_COMPONENT_NAME Runtime)

if(ENABLE_CALCEPH)
    list(APPEND INSTALL_TARGETS solsys-calceph)
endif()

if(ENABLE_CSPICE)
    list(APPEND INSTALL_TARGETS solsys-cspice)
endif()

install(TARGETS ${INSTALL_TARGETS} EXPORT supernovasTargets)


# ------------------------------------------------------------------------
# Install Development component

install(FILES include/novas.h
    TYPE INCLUDE
    COMPONENT Development
)

if(ENABLE_CALCEPH)
   install(FILES include/novas-calceph.h
       TYPE INCLUDE
       COMPONENT Development
   )
endif()

if(ENABLE_CSPICE)
   install(FILES include/novas-cspice.h
       TYPE INCLUDE
       COMPONENT Development
   )
endif()

# Install CHANGELOG
install(FILES CHANGELOG.md 
  TYPE DOC
  COMPONENT Development   
)

# Install CONTRIBUTING.md (Development)
install(FILES CONTRIBUTING.md 
    TYPE DOC
    COMPONENT Development     
)

# For examples/ dir, list just the directory, not the individual files installed.
install(CODE "message(STATUS \"Installing: <prefix>/${CMAKE_INSTALL_DOCDIR}/examples/*\")")
install(DIRECTORY ${PROJECT_SOURCE_DIR}/examples
   TYPE DOC
   MESSAGE_NEVER
   COMPONENT Development
)

# For legacy/ dir, list just the directory, not the individual files installed.
install(CODE "message(STATUS \"Installing: <prefix>/${CMAKE_INSTALL_DOCDIR}/legacy/*\")")
install(DIRECTORY ${PROJECT_SOURCE_DIR}/legacy
   TYPE DOC
   MESSAGE_NEVER
   COMPONENT Development
)

install(EXPORT supernovasTargets
    COMPONENT Development
    FILE supernovasTargets.cmake
    NAMESPACE supernovas::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/supernovas
)


# ------------------------------------------------------------------------
# Package config

configure_package_config_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/cmake/supernovasConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/supernovasConfig.cmake
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/supernovas
)

write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/supernovasConfigVersion.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY SameMajorVersion
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/supernovasConfig.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/supernovasConfigVersion.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/supernovas
    COMPONENT Development
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/cmake/supernovas.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/supernovas.pc
    @ONLY
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/supernovas.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
    COMPONENT Development
)

# ----------------------------------------------------------------------------
# Uninstall target
if(NOT TARGET uninstall)
    configure_file(
        "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
        "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
        IMMEDIATE @ONLY
    )

    add_custom_target(uninstall
        COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
    )
endif()

# ----------------------------------------------------------------------------
# Export the package for use from the build-tree
# (this registers the build-tree with a global CMake-registry)
export(PACKAGE supernovas)


# ----------------------------------------------------------------------------
# Summary
feature_summary(WHAT ALL)

message(" - Compile flags added with CMAKE_BUILD_TYPE:")
message("   Debug:             ${CMAKE_C_FLAGS_DEBUG}")
message("   Release:           ${CMAKE_C_FLAGS_RELEASE}")
message("   RelWithDebInfo:    ${CMAKE_C_FLAGS_RELWITHDEBINFO}")
message("   MinSizeRel:        ${CMAKE_C_FLAGS_MINSIZEREL}")
message("")

message(" - supernovas Configuration Summary:")
message("   Version:           ${PROJECT_VERSION}")
if(CMAKE_BUILD_TYPE)
    message("   Build type:        ${CMAKE_BUILD_TYPE}")
else()
    message("   Build type:        (default) -- external CFLAGS only")
endif()
message("   Install prefix:    ${CMAKE_INSTALL_PREFIX}")
message("   Compiler:          ${CMAKE_C_COMPILER_ID} ${CMAKE_C_COMPILER_VERSION}")
message("")

=== Makefile ===

# ===============================================================================
# WARNING! You should leave this Makefile alone probably
#          To configure the build, you can edit config.mk, or else you export the 
#          equivalent shell variables prior to invoking 'make' to adjust the
#          build configuration. 
# ===============================================================================

include config.mk

# ===============================================================================
# Specific build targets and recipes below...
# ===============================================================================

# We'll need math functions to link
LDFLAGS += -lm

# If there is doxygen, build the API documentation also by default
ifeq ($(.SHELLSTATUS),0)
  DOC_TARGETS += local-dox
else
  ifneq ($(DOXYGEN),none)
    $(info WARNING! Doxygen is not available. Will skip 'dox' target)
  endif
endif

SOLSYS_TARGETS :=
SHARED_TARGETS := $(LIB)/libsupernovas.$(SOEXT) $(LIB)/libnovas.$(SOEXT)

ifeq ($(CALCEPH_SUPPORT), 1)
  CPPFLAGS += -DUSE_CALCEPH=1
  SOLSYS_TARGETS += $(OBJ)/solsys-calceph.o
  SHARED_TARGETS += $(LIB)/libsolsys-calceph.$(SOEXT)
endif

ifeq ($(CSPICE_SUPPORT), 1)
  CPPFLAGS += -DUSE_CSPICE=1
  SOLSYS_TARGETS += $(OBJ)/solsys-cspice.o
  SHARED_TARGETS += $(LIB)/libsolsys-cspice.$(SOEXT)
endif

# Default target for packaging with Linux distributions
.PHONY: distro
distro: $(SHARED_TARGETS) $(DOC_TARGETS)

# Shared libraries (versioned and unversioned)
.PHONY: shared
shared: summary $(SHARED_TARGETS)

# Static libraries
.PHONY: static
static: summary $(LIB)/libnovas.a solsys

# solarsystem() call handler objects
.PHONY: solsys
solsys: $(SOLSYS_TARGETS)

# All of the above
.PHONY: all
all: distro static test coverage analyze

# Run regression tests
.PHONY: test
test:
	$(MAKE) -C test run

.PHONY: benchmark
benchmark: shared
	$(MAKE) -C benchmark

.PHONY: examples
examples: shared
	$(MAKE) -C examples

# Perform checks (test + analyze)
.PHONY: check
check: test analyze

# Measure test coverage (on test set of files only)
.PHONY: coverage
coverage:
	$(MAKE) -C test coverage

# Remove intermediates
.PHONY: clean
clean:
	@rm -f $(OBJECTS) Doxyfile.local gmon.out
	@$(MAKE) -s -C test clean
	@$(MAKE) -s -C benchmark clean
	@$(MAKE) -s -C examples clean
	@$(MAKE) -s -C doc clean

# Remove all generated files
.PHONY: distclean
distclean: clean
	@rm -f $(LIB)/libsupernovas.$(SOEXT)* $(LIB)/libsupernovas.a $(LIB)/libnovas.a \
      $(LIB)/libnovas.$(SOEXT)* $(LIB)/libsolsys*.$(SOEXT)*
	@rm -f doc/Doxyfile.local doc/README.md
	@rm -rf build */build 
	@$(MAKE) -s -C test distclean
	@$(MAKE) -s -C benchmark distclean
	@$(MAKE) -s -C examples distclean
	@$(MAKE) -s -C doc distclean

.PHONY: dox
dox:
	DOXYGEN_HTML_HEADER="resources/header.html" $(MAKE) -C doc

.PHONY: local-dox
local-dox:
	$(MAKE) -C doc


# ----------------------------------------------------------------------------
# The nitty-gritty stuff below
# ----------------------------------------------------------------------------

$(LIB)/libsupernovas.$(SOEXT): $(LIB)/libsupernovas.$(SOEXT).$(SO_VERSION)

$(LIB)/libsolsys-calceph.$(SOEXT): $(LIB)/libsolsys-calceph.$(SOEXT).$(SO_VERSION)

$(LIB)/libsolsys-cspice.$(SOEXT): $(LIB)/libsolsys-cspice.$(SOEXT).$(SO_VERSION)

$(LIB)/libnovas.$(SOEXT): $(LIB)/libsupernovas.$(SOEXT)

# Shared library: libsupernovas.so.1 -- same as novas.so except the builtin SONAME
$(LIB)/libsupernovas.$(SOEXT).$(SO_VERSION): $(SOURCES)

# Shared library: libsolsys-calceph.so.1 (standalone solsys2.c functionality)
$(LIB)/libsolsys-calceph.$(SOEXT).$(SO_VERSION): SHLIBS := -lcalceph -lpthread
$(LIB)/libsolsys-calceph.$(SOEXT).$(SO_VERSION): $(SRC)/solsys-calceph.c

# Shared library: libsolsys-cspice.so.1 (standalone solsys2.c functionality)
$(LIB)/libsolsys-cspice.$(SOEXT).$(SO_VERSION): SHLIBS := -lcspice -lpthread
$(LIB)/libsolsys-cspice.$(SOEXT).$(SO_VERSION): $(SRC)/solsys-cspice.c

# Link submodules against the supernovas shared lib
$(LIB)/libsolsys%.$(SOEXT).$(SO_VERSION): | $(LIB) $(LIB)/libsupernovas.$(SOEXT).$(SO_VERSION)
	$(CC) -o $@ $(CPPFLAGS) $(CFLAGS) $^ $(SHARED_FLAGS) $(SONAME_FLAG)$(notdir $@) -L$(LIB) -lsupernovas $(SHLIBS) $(LDFLAGS)

# Static library: libsupernovas.a
$(LIB)/libsupernovas.a: $(OBJECTS) | $(LIB) Makefile

$(LIB)/libnovas.a: $(LIB)/libsupernovas.a
	@rm -f $@
	( cd $(LIB); ln -s libsupernovas.a libnovas.a )

# Standard install commands
INSTALL_PROGRAM ?= install
INSTALL_DATA ?= install -m 644

.PHONY: install
install: install-libs install-headers install-docs install-legacy

.PHONY: install-libs
install-libs:
ifneq ($(wildcard $(LIB)/*),)
	@echo "installing libraries to $(DESTDIR)$(libdir)"
	install -d $(DESTDIR)$(libdir)
	cp -a $(LIB)/* $(DESTDIR)$(libdir)/
else
	@echo "WARNING! Skipping libs install: needs 'shared' and/or 'static'"
endif

.PHONY: install-calceph-headers
install-calceph-headers:
ifeq ($(CALCEPH_SUPPORT),1)
	$(INSTALL_DATA) include/novas-calceph.h $(DESTDIR)$(includedir)/
endif

.PHONY: install-cspice-headers
install-cspice-headers:
ifeq ($(CSPICE_SUPPORT),1) 
	$(INSTALL_DATA) include/novas-cspice.h $(DESTDIR)$(includedir)/
endif

.PHONY: install-headers
install-headers:
	@echo "installing headers to $(DESTDIR)$(includedir)"
	install -d $(DESTDIR)$(includedir)
	$(INSTALL_DATA) include/novas.h $(DESTDIR)$(includedir)/
	@$(MAKE) install-calceph-headers
	@$(MAKE) install-cspice-headers

.PHONY: install-docs
install-docs: install-markdown install-html install-examples install-legacy

.PHONY: install-markdown
install-markdown:
	@echo "installing documentation to $(DESTDIR)$(docdir)"
	install -d $(DESTDIR)$(docdir)
	$(INSTALL_DATA) doc/*.md $(DESTDIR)$(docdir)/
	$(INSTALL_DATA) CHANGELOG.md $(DESTDIR)$(docdir)/
	$(INSTALL_DATA) CONTRIBUTING.md $(DESTDIR)$(docdir)/

.PHONY: install-html
install-html:
ifneq ($(wildcard doc/html/search/*),)
	@echo "installing API documentation to $(DESTDIR)$(htmldir)"
	install -d $(DESTDIR)$(htmldir)/search
	$(INSTALL_DATA) doc/html/search/* $(DESTDIR)$(htmldir)/search/
	$(INSTALL_DATA) doc/html/*.* $(DESTDIR)$(htmldir)/
	@echo "installing Doxygen tag file to $(DESTDIR)$(docdir)"
	install -d $(DESTDIR)$(docdir)
	$(INSTALL_DATA) doc/supernovas.tag $(DESTDIR)$(docdir)/supernovas.tag
else
	@echo "WARNING! Skipping HTML docs install: needs doxygen and 'local-dox'"
endif

.PHONY: install-examples
install-examples:
	@echo "installing examples to $(DESTDIR)$(docdir)/examples"
	install -d $(DESTDIR)$(docdir)/examples
	$(INSTALL_DATA) examples/* $(DESTDIR)$(docdir)/examples/

.PHONY: install-legacy
install-legacy:
	@echo "installing legacy files to $(DESTDIR)$(docdir)/legacy"
	install -d $(DESTDIR)$(docdir)/legacy
	$(INSTALL_DATA) legacy/* $(DESTDIR)$(docdir)/legacy/

# Some standard GNU targets, that should always exist...
.PHONY: html
html: local-dox

.PHONY: dvi
dvi:

.PHONY: ps
ps:

.PHONY: pdf
pdf:

# Build configuration summary
.PHONY: summary
summary:
	@echo
	@echo "SuperNOVAS build configuration:"
	@echo
	@echo "    CALCEPH_SUPPORT      = $(CALCEPH_SUPPORT)"
	@echo "    CSPICE_SUPPORT       = $(CSPICE_SUPPORT)"
	@echo "    SOLSYS_SOURCES       = $(SOLSYS_SOURCES)"
	@echo "    READEPH_SOURCES      = $(READEPH_SOURCES)"
	@echo
	@echo "    CC      = $(CC)" 
	@echo "    CFLAGS  = $(CFLAGS)"
	@echo "    LDFLAGS = $(LDFLAGS)"
	@echo

# Built-in help screen for `make help`
.PHONY: help
help:
	@echo
	@echo "Syntax: make [target]"
	@echo
	@echo "The following tairgets are available:"
	@echo
	@echo "  distro        (default) 'shared' targets and also 'local-dox' provided 'doxygen'" 
	@echo "                is available, or was specified via the DOXYGEN variable (e.g. in"
	@echo "                'config.mk')"
	@echo "  static        Builds the static 'lib/libsupernovas.a' library."
	@echo "  shared        Builds the shared 'libsupernovas.so', 'libsolsys1.so', and" 
	@echo "                'libsolsys2.so' libraries (linked to versioned ones)."
	@echo "  local-dox     Compiles local HTML API documentation using 'doxygen'."
	@echo "  solsys        Builds only the objects that may provide external 'solarsystem()'"
	@echo "                call implentations (e.g. 'solsys1.o', 'eph_manager.o'...)."
	@echo "  test          Runs regression tests."
	@echo "  benchmark     Runs benchmarks."
	@echo "  analyze       Performs static code analysis with 'cppcheck'."
	@echo "  check         Same as 'test' and then 'analyze'."
	@echo "  coverage      Runs 'gcov' to analyze regression test coverage."
	@echo "  summary       Provides a summary of the current build configuration."
	@echo "  all           All of the above."
	@echo "  install       Install components (e.g. 'make prefix=<path> install')"
	@echo "  clean         Removes intermediate products."
	@echo "  distclean     Deletes all generated files."
	@echo

# This Makefile depends on the config and build snipplets.
Makefile: config.mk build.mk

# ===============================================================================
# Generic targets and recipes below...
# ===============================================================================

include build.mk

=== benchmark/CMakeLists.txt ===
# Additional CMake configuration file for building the benchmarking programs
# of the SuperNOVAS library.
#
# To invoke simply configure the cmake build in the supernovas directory with
# the -DBUILD_BENCHMARK=ON option.
#
# Author: Attila Kovacs

# List of benchmarking programs to build
set(BENCHMARK_PROGRAMS
    benchmark-nutation
    benchmark-place
)

include_directories(${supernovas_INCLUDE_DIRS})

# Build each example
foreach(BENCHMARK ${BENCHMARK_PROGRAMS})
    set(BENCHMARK_SOURCE ${BENCHMARK}.c)

    if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${BENCHMARK_SOURCE})
        add_executable(${BENCHMARK} ${BENCHMARK_SOURCE})

        # Link against the supernovas library
        target_link_libraries(${BENCHMARK} PRIVATE
            supernovas::core
            ${MATH}
        )
    else()
        message(WARNING "Source file ${BENCHMARK_SOURCE} not found - ${BENCHMARK} will not be built")
    endif()
endforeach()

=== benchmark/Makefile ===
# Part of SuperNOVAS
#
# Generates headless README.md and HTML documentation 
#
# Author: Attila Kovacs

# Use the definitions project definitions
include ../config.mk

BENCHMARKS = benchmark-nutation benchmark-place

CPPFLAGS += -I../include
LDFLAGS += -L../$(LIB) -lsupernovas

.PHONY: all
all: build run

.PHONY: build
build: $(BENCHMARKS)

.PHONY: run
run: build
	@for prog in $(BENCHMARKS) ; do $(LIB_PATH_VAR)=../$(LIB) ./$${prog} ; done

.PHONY: clean
clean:

.PHONY: distclean
distclean: clean
	@rm -f $(BENCHMARKS)

benchmark-%: benchmark-%.c
	$(CC) -o $@ $(CPPFLAGS) $(CFLAGS) $< $(LDFLAGS)

# Built-in help screen for `make help`
.PHONY: help
help:
	@echo
	@echo "Syntax: make [target]"
	@echo
	@echo "The following targets are available:"
	@echo
	@echo "  all           (default) builds and runs benchmarks."
	@echo "  build         Builds benchmarks."
	@echo "  run           Runs benchmarks."
	@echo "  clean         Removes intermediate products."
	@echo "  distclean     Deletes all generated files."
	@echo

=== doc/CMakeLists.txt ===
# Additional CMake configuration file for building the documentation of the 
# SuperNOVAS library. The examples are also added to the test suite so they 
# may be checked for functionality.
#
# To invoke simply configure the cmake build in the supernovas directory with
# the -DBUILD_DOC=ON option.
#
# Author: Attila Kovacs

# ----------------------------------------------------------------------------
# Generate derivative documentation

# Generate headless README
add_executable(docedit EXCLUDE_FROM_ALL src/docedit.c)

add_custom_target(headless_readme ALL
    COMMAND docedit ${CMAKE_CURRENT_SOURCE_DIR}
)

# Install Markdown documentation (Development)
file(GLOB MD_FILES doc/*.md)
install(FILES ${MD_FILES}
    COMPONENT Development
    DESTINATION ${CMAKE_INSTALL_DOCDIR}
)

find_package(Doxygen)

set_package_properties(Doxygen PROPERTIES
    URL "https://doxygen.nl/"
    DESCRIPTION  "is a widely-used documentation generator tool in software development"
    TYPE OPTIONAL
    PURPOSE "Enables HTML documentation for supernovas"
)

if(Doxygen_FOUND)
    # Generate headless docs and run Doxygen on them.
    doxygen_add_docs(project_docs ALL CONFIG_FILE ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile)
    add_dependencies(project_docs headless_readme)
    
     # For html/ dir, list just the directory, not the individual files installed.
    install(CODE "message(STATUS \"Installing: <prefix>/${CMAKE_INSTALL_DOCDIR}/html/*\")")
    install(DIRECTORY html
        DESTINATION ${CMAKE_INSTALL_DOCDIR}
        MESSAGE_NEVER
        COMPONENT Development
    )

    # Install Doxygen tag, which downstream docs can link to.
    install(FILES supernovas.tag
        DESTINATION ${CMAKE_INSTALL_DOCDIR}
        COMPONENT Development
    )
else()
    message(WARNING "Doxygen not found -- Will skip generating HTML documentation")
endif()

=== doc/Makefile ===
# Part of SuperNOVAS
#
# Generates headless README.md and HTML documentation 
#
# Author: Attila Kovacs

# Check if there is a doxygen we can run
ifndef DOXYGEN
  DOXYGEN := $(shell which doxygen)
else
  $(shell test -f $(DOXYGEN))
endif

CC ?= gcc

# Doxygen documentation (HTML and man pages) under apidocs/
.PHONY: all
all: Doxyfile README.md $(SRC) $(INC)
	@echo "   [doxygen]"
	@$(DOXYGEN) Doxyfile

.INTERMEDIATE: docedit
docedit: src/docedit.o
	$(CC) -o $@ $^

# Generate headless and undecorated README variants
README.md: ../README.md docedit
	@echo "   [README variants]"
	@./docedit

.PHONY: clean
clean:
	rm -f docedit *.tag

.PHONY: distclean
distclean: clean
	rm -rf README*.md html

=== examples/CMakeLists.txt ===
# Additional CMake configuration file for building the example programs of the 
# supernovas library. The examples are also added to the test suite so they 
# may be checked for functionality.
#
# To invoke simply configure the cmake build in the supernovas directory with
# the -DBUILD_EXAMPLES=ON option.
#
# Author: Attila Kovacs

cmake_minimum_required(VERSION 3.20)

# Configuration in case this is a standalone project....
if(NOT PROJECT_NAME)
    project(supernovas-examples 
        VERSION 1.5.0
        DESCRIPTION "SuperNOVAS example programs"
        HOMEPAGE_URL "https://smithsonian.github.io/SuperNOVAS/"
        LANGUAGES C
    )
    
    include(GNUInstallDirs)
        
    find_package(supernovas)

    if(WIN32)
        set(MATH "")
    else()
        find_library(MATH_LIBRARY m REQUIRED)
        set(MATH m)
    endif()
endif()

# List of example programs to build
set(EXAMPLE_PROGRAMS
    example-star
    example-time
    example-high-z
    example-orbital
    example-rise-set
)

if(supernovas_solsys-calceph_FOUND)
    list(APPEND EXAMPLE_PROGRAMS example-calceph)
endif()

if(supernovas_solsys-cspice_FOUND)
    list(APPEND EXAMPLE_PROGRAMS example-cspice)
endif()

# The ephemeris data to use for CALCEPH / CSPICE testing
set(EPHEM ${PROJECT_SOURCE_DIR}/test/ephem/de440s-j2000.bsp)

message("include dirs is ${supernovas_INCLUDE_DIRS}")

# Build each example
foreach(EXAMPLE ${EXAMPLE_PROGRAMS})
    set(EXAMPLE_SOURCE ${EXAMPLE}.c)

    if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${EXAMPLE_SOURCE})
        add_executable(${EXAMPLE} ${EXAMPLE_SOURCE})

        target_include_directories(${EXAMPLE} PRIVATE ${supernovas_INCLUDE_DIRS})

        # Link against the supernovas library
        target_link_libraries(${EXAMPLE} PRIVATE
            supernovas::core
            ${MATH}
        )

        # Special handling for CALCEPH example
        if(${EXAMPLE} STREQUAL "example-calceph")
            find_dependency(calceph)
        
            target_link_libraries(${EXAMPLE} PRIVATE
                supernovas::solsys-calceph
                calceph
            )
            #add_test(NAME ${EXAMPLE} COMMAND ${EXAMPLE} ${EPHEM})
            
        # Special handling for CSPICE example
        elseif(${EXAMPLE} STREQUAL "example-cspice")
       	    find_dependency(cspice)
        
            target_link_libraries(${EXAMPLE} PRIVATE
                supernovas::solsys-cspice
                cspice
            )
            #add_test(NAME ${EXAMPLE} COMMAND ${EXAMPLE} ${EPHEM})
        
        # All other tests
        else()
            add_test(NAME ${EXAMPLE} COMMAND ${EXAMPLE})
        endif()

    else()
        message(WARNING "Source file ${EXAMPLE_SOURCE} not found - ${EXAMPLE} will not be built")
    endif()
endforeach()

=== examples/Makefile ===
# Part of SuperNOVAS
#
# Build exammple programs
#
# Author: Attila Kovacs

# Use the definitions project definitions
include ../config.mk

EXAMPLES = example-star example-high-z example-orbital example-time example-rise-set

CPPFLAGS += -I../include
LDFLAGS += -L../$(LIB) -lsupernovas

ifeq ($(CALCEPH_SUPPORT),1)
  EXAMPLES += example-calceph
  LDFLAGS += -lsolsys-calceph -lcalceph
endif

ifeq ($(CSPICE_SUPPORT),1)
  EXAMPLES += example-cspice
  LDFLAGS += -lsolsys-cspice -lcspice
endif

.PHONY: all
all: $(EXAMPLES)

# Static code analysis using 'cppcheck'
.PHONY: analyze
analyze:
	@echo "   [analyze]"
	@cppcheck $(CPPFLAGS) $(CHECKOPTS) .

.PHONY: clean
clean:

.PHONY: distclean
distclean:
	rm -f $(EXAMPLES)

example-%: example-%.c
	$(CC) -o $@ $(CPPFLAGS) $(CFLAGS) $< $(LDFLAGS)

.PHONY: help
help:
	@echo
	@echo "Syntax: make [target]"
	@echo
	@echo "The following targets are available:"
	@echo
	@echo "  all           (default) Build all example programs."
	@echo "  analyze       Runs 'cppcheck' static analysis tool on sources."
	@echo "  clean         Removes intermediate products."
	@echo "  distclean     Deletes all generated files."
	@echo

=== test/CMakeLists.txt ===
# Additional CMake configuration file for building the regression testing programs
# of the SuperNOVAS library. The programs are added to the test suite.
#
# To invoke simply configure the cmake build in the supernovas directory with
# the -DBUILD_TESTING=ON option.
#
# Author: Attila Kovacs

# List of test programs to build
set(TEST_PROGRAMS
    test-compat
    test-super
    test-errors
)

if(ENABLE_CALCEPH)
    list(APPEND TEST_PROGRAMS test-calceph)
endif()

if(ENABLE_CSPICE)
    list(APPEND TEST_PROGRAMS test-cspice)
endif()

include_directories(${supernovas_INCLUDE_DIRS} ${PROJECT_SOURCE_DIR}/legacy)

# Link against binaries in the local supernovas lib/ directory
link_directories(${CMAKE_BINARY_DIR}/lib)

# Directory where ephemeris data for the tests are found
set(EPHEM_DIR ${PROJECT_SOURCE_DIR}/test/ephem)

# Create a data/ directory for the compat test output
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/data)

# Build each example
foreach(TEST ${TEST_PROGRAMS})
    set(TEST_SOURCE src/${TEST}.c)

    if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${TEST_SOURCE})
        add_executable(${TEST} ${TEST_SOURCE})
              
        target_include_directories(${TEST} PRIVATE
            ${PROJECT_SOURCE_DIR}/include
        )
        
        # Link against the supernovas library
        target_link_libraries(${TEST} PRIVATE
            supernovas::core
            ${MATH}
        )

        # Special handling for CALCEPH example
        if(${TEST} STREQUAL "test-calceph")
            find_library(CALCEPH_LIB calceph REQUIRED)
            target_link_libraries(${TEST} PRIVATE
                supernovas::solsys-calceph
                ${CALCEPH_LIB}
            )
     	    add_test(NAME ${TEST} COMMAND ${TEST} ${EPHEM_DIR})
     	    
        # Special handling for CSPICE example
        elseif(${TEST} STREQUAL "test-cspice")
            find_library(CSPICE_LIB cspice REQUIRED)
            target_link_libraries(${TEST} PRIVATE
                supernovas::solsys-cspice
                ${CSPICE_LIB}
            )
            add_test(NAME ${TEST} COMMAND ${TEST} ${EPHEM_DIR})
        
        # All other examples
     	else()
     	    add_test(NAME ${TEST} COMMAND ${TEST})
        endif()
        
    else()
        message(WARNING "Source file ${TEST_SOURCE} not found - ${TEST} will not be built")
    endif()
endforeach()

=== test/Makefile ===
# Part of SuperNOVAS
#
# Builds and runs regression tests, measures test coverage
#
# Author: Attila Kovacs

include ../config.mk

# Flags for measuring test coverage
CFLAGS += -I../include -I../legacy -pg -Wall -fprofile-arcs -ftest-coverage
LDFLAGS += -fprofile-arcs -ftest-coverage -lm

# cppcheck options for 'check' target. You can add additional options by
# setting the CHECKEXTRA variable (e.g. in shell) prior to invoking 'make'.
CHECKOPTS = --enable=performance,warning,portability --language=c \
            --error-exitcode=1 --std=c99 --inline-suppr $(CHECKEXTRA)

OBJECTS := $(subst $(OBJ)/,,$(OBJECTS))
COVFILES := $(subst .o,.c.gcov,$(OBJECTS))

TESTS := test-compat test-super test-errors

ifeq ($(CALCEPH_SUPPORT), 1)
  TESTS += test-calceph
  LDFLAGS += -lcalceph
  OBJECTS += solsys-calceph.o
  COVFILES += solsys-calceph.c.gcov
endif

ifeq ($(CSPICE_SUPPORT), 1)
  TESTS += test-cspice
  LDFLAGS += -lcspice
  OBJECTS += solsys-cspice.o
  COVFILES += solsys-cspice.c.gcov
endif

.PHONY: check-compat
check-compat:
	@sed -i.tmp "s:-nan: nan:g" data/* && rm -f data/*.tmp
	diff data reference

.PHONY: run
run: clean-cov clean-data $(TESTS)
	@mkdir data
	./test-compat
	$(MAKE) check-compat
	./test-super
	./test-errors
ifeq ($(CALCEPH_SUPPORT), 1)
	./test-calceph ephem
endif
ifeq ($(CSPICE_SUPPORT), 1)
	./test-cspice ephem
endif

cov: cov.info
	genhtml $< -o $@

cov.info:
	geninfo . -b . -o $@

.PHONY: coverage

coverage: $(COVFILES)
	$(MAKE) clean-test
	$(MAKE) cov

.PRECIOUS: %.c.gcov
%.c.gcov: %.gcno %.gcda
	gcov -b $*

.PRECIOUS: %.gcno %.gcda
%.gcno %.gcda: ../src/%.c
	$(MAKE) clean
	$(MAKE) run

test-%: test-%.o $(OBJECTS) | Makefile
	$(CC) -o $@ $^ $(LDFLAGS)

test-%.o: src/test-%.c | Makefile
	$(CC) -c -o $@ $(CPPFLAGS) $(CFLAGS) $<

%.o: ../src/%.c | Makefile
	$(CC) -c -o $@ $(CPPFLAGS) $(CFLAGS) $<

test-calceph: LDFLAGS += -lcalceph

test-cspice: LDFLAGS += -lcspice

# Static code analysis using 'cppcheck'
.PHONY: analyze
analyze:
	@echo "   [analyze]"
	@cppcheck $(CPPFLAGS) $(CHECKOPTS) $(SRC)

.PHONY: clean-test
clean-test:
	rm -f test-*

.PHONY: clean-cov
clean-cov:
	rm -rf gmon.out *.gcov *.gcda *.gcno cov cov.info

.PHONY: clean-data
clean-data:
	rm -rf data

.PHONY: clean
clean: clean-test clean-cov
	rm -f *.o

.PHONY: distclean
distclean: clean clean-data

.PHONY: help
help:
	@echo
	@echo "Syntax: make [target]"
	@echo
	@echo "The following targets are available:"
	@echo
	@echo "  run           (default) Compiles and runs regression tests."
	@echo "  coverage      Extracts test coverage data."
	@echo "  analyze       Static analysis with cppcheck."
	@echo "  clean         Removes intermediate products."
	@echo "  distclean     Deletes all generated files."
	@echo


vpath %.c ../src
vpath %.c src

=== debian/changelog ===
supernovas (1.5.0-1) unstable; urgency=medium

  * Removed legacy solsys1 / solsys2 sub-packages, no longer built upstream
  * Removed cio-data sub-packaged (no longer used, needed)
  * dev sub-package installes CMake / pkgconfig configurations
  * Switched to CMake for package build
  * Updated to upstream v1.5.0 -- feature release with fixes. 

 -- Attila Kovacs <attipaci@gmail.com>  Fri, 31 Oct 2025 11:54:58 +0100

supernovas (1.4.2-3) unstable; urgency=medium

  * Allow solsys1 / solsys2 sub-packages to work with future versions

 -- Attila Kovacs <attipaci@gmail.com>  Wed, 24 Sep 2025 17:42:15 +0200

=== debian/control ===
Source: supernovas
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Attila Kovacs <attila.kovacs@cfa.harvard.edu>
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 13), cmake, libcalceph-dev
Build-Depends-Indep: doxygen
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian-astro-team/supernovas
Vcs-Git: https://salsa.debian.org/debian-astro-team/supernovas.git
Homepage: https://smithsonian.github.io/SuperNOVAS
Rules-Requires-Root: no

Package: libsupernovas1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: libsolsys-calceph1 (= ${binary:Version})
Description: SuperNOVAS C/C++ astrometry library
 SuperNOVAS is a C/C++ astronomy library, providing high-precision astronomical
 calculations such as one might need for running an observatory or a precise
 planetarium program. It is a fork of the Naval Observatory Vector Astrometry
 Software (NOVAS) C version 3.1, providing bug fixes and making it easier to
 use overall.
 .
 The main goals of SuperNOVAS are to improve usability, add new features,
 promote best practices, and provide accessible documentation -- all while
 retaining 100% API compatibility with NOVAS C 3.1. Thus, if you have written
 code for NOVAS C 3.1, you can build it with SuperNOVAS also.
 SuperNOVAS is entirely free to use without licensing restrictions. Its source
 code is compatible with the C90 standard, and hence should be suitable for old
 and new platforms alike. It is light-weight and easy to use, with full support
 for the IAU 2000/2006 standards for sub-micro-arc-second position.

Package: libsolsys-calceph1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libsupernovas1 (= ${binary:Version}),
         libcalceph2
Description: Optional SuperNOVAS plugin library that provides Solar-system
 support via the CALCEPH C library. It allows using both JPL (SPK) and INPOP
 2.0/3.0 data files with SuperNOVAS to obtain precise locations for
 Solar-system bodies. This plugin is currently the preferred option to use for
 Fedora / RPM Linux development, which requires use of precise Solar-system
 data.

Package: libsupernovas-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libsupernovas1 (= ${binary:Version}),
         libsolsys-calceph1 (= ${binary:Version})
Description: C development files for the SuperNOVAS C/C++ astronomy library
 This sub-package provides C headers and non-versioned shared library symbolic
 links for the SuperNOVAS C/C++ library.

Package: libsupernovas-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: Documentation for the SuperNOVAS C/C++ astronomy library
 This package provides man pages and HTML documentation for the SuperNOVAS
 C/C++ astronomy library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ -Scmake

override_dh_auto_configure:
	dh_auto_configure -- \
	  -DBUILD_SHARED_LIBS=ON -DBUILD_TESTING=ON -DBUILD_DOC=ON -DENABLE_CALCEPH=ON

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG.md

=== debian/tests/control ===
Tests: test-basic
Depends: @, build-essential, shunit2
Restrictions: allow-stderr

Tests: test-calceph
Depends: @, build-essential, libcalceph-dev, shunit2
Restrictions: allow-stderr

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[.\d-rc]*)\.tar\.gz%supernovas-$1.tar.gz%, \
uversionmangle=s:(\d)-rc(\d*):$1~rc$2:" \
   https://github.com/Smithsonian/SuperNOVAS/tags \
   .*?@ANY_VERSION@@ARCHIVE_EXT@

## supernovas 1.5.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
 #
 
 
-cmake_minimum_required(VERSION 3.20)
+cmake_minimum_required(VERSION 3.24...4.2)
 
 # Project definition
 project(supernovas
@@ -71,9 +71,6 @@
 
 # Debug postfix for libraries
 set(CMAKE_DEBUG_POSTFIX d)
-
-# Position Independent Code for shared libs
-set(CMAKE_POSITION_INDEPENDENT_CODE ON)
 
 # Build time locations for sub-configs
 link_directories(${CMAKE_BINARY_DIR}/lib)
@@ -167,10 +164,7 @@
 set_target_properties(core PROPERTIES
     VERSION ${PROJECT_VERSION}
     SOVERSION ${PROJECT_VERSION_MAJOR}
-    POSITION_INDEPENDENT_CODE ON
-    EXPORT_NAME supernovas
     OUTPUT_NAME supernovas
-    CLEAN_DIRECT_OUTPUT ON
 )
 
 target_include_directories(core PUBLIC
@@ -180,7 +174,7 @@
 
 # Link with math libs as necessary
 if(MATH_LIB)
-    target_link_libraries(core PRIVATE ${MATH})
+    target_link_libraries(core ${MATH})
 endif()
 
 # ----------------------------------------------------------------------------
@@ -196,7 +190,6 @@
     set_target_properties(${PLUGIN} PROPERTIES
         VERSION ${PROJECT_VERSION}
         SOVERSION ${PROJECT_VERSION_MAJOR}
-        POSITION_INDEPENDENT_CODE ON
     )
     
     if(CMAKE_USE_PTHREADS_INIT)
@@ -208,7 +201,7 @@
     
     find_library(EPHEM_LIBRARY ${EPHEM_LIB_NAME} REQUIRED)
     
-    target_link_libraries(solsys-${EPHEM_LIB_NAME} PRIVATE
+    target_link_libraries(solsys-${EPHEM_LIB_NAME}
         supernovas::core
         ${EPHEM_LIBRARY}
         ${MATH}

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 #
 # Author: Attila Kovacs
 
-cmake_minimum_required(VERSION 3.20)
+cmake_minimum_required(VERSION 3.20...4.2)
 
 # Configuration in case this is a standalone project....
 if(NOT PROJECT_NAME)

=== debian/changelog ===
supernovas (1.5.1-2) unstable; urgency=medium

  * Back to version 4 for watch file (for now).

 -- Attila Kovacs <attipaci@gmail.com>  Sat, 03 Jan 2026 23:32:10 +0100

supernovas (1.5.1-1) unstable; urgency=medium

  * Updated to upstream v1.5.1 -- bug fix release (Closes: #1122486).
  * Updated standards to 4.7.3
  * Updated watch standards to 5
  * Follow lintian proposals

 -- Attila Kovacs <attipaci@gmail.com>  Fri, 02 Jan 2026 11:48:19 +0100

=== debian/control ===
--- 
+++ 
@@ -5,11 +5,10 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13), cmake, libcalceph-dev
 Build-Depends-Indep: doxygen
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/debian-astro-team/supernovas
 Vcs-Git: https://salsa.debian.org/debian-astro-team/supernovas.git
 Homepage: https://smithsonian.github.io/SuperNOVAS
-Rules-Requires-Root: no
 
 Package: libsupernovas1
 Architecture: any
